#ifndef __SD_CELL__
#define __SD_CELL__

#include <iostream>
#include <fstream>

#include "util.h"

namespace SD {

struct Cell {
    Label label;
    Cell* next;
    Cell* prev;
    Real  alpha;   // forward-Viterbi score
    Real  beta;    // backward-Viterbi score
    Real  lb;
    Cell* backlink;
};

struct cmp_cell {
    bool operator()( const Cell& rhs, const Cell& lhs ) const {
	return rhs.alpha > lhs.alpha;
    }
};

struct cmp_alpha {
    bool operator()( const Cell& rhs, const Cell& lhs ) const {
	return rhs.alpha > lhs.alpha;
    }
};

struct cmp_beta {
    bool operator()( const Cell& rhs, const Cell& lhs ) const {
	return rhs.beta > lhs.beta;
    }
};

}

#endif
