#include <iostream>
#include <fstream>

#include "hmm_trainer.h"
#include "util.h"

using namespace SD;

int main( int argc, const char** argv ) {

    if ( argc != 3 ) {
	fprintf( stderr, "%s <train> <model>\n", argv[0] );
	return FAILURE;
    }
    const char* trainfile = argv[argc-2];
    const char* modelfile = argv[argc-1];

    HMMTrainer trainer;
    if ( trainer.preprocess( trainfile ) == FAILURE ) return FAILURE;
    if ( trainer.train( trainfile ) == FAILURE ) return FAILURE;
    if ( trainer.save( modelfile ) == FAILURE ) return FAILURE;
    
    return SUCCESS;
}
