#ifndef __UTIL__
#define __UTIL__

#include <float.h>    // FLT_MAX

namespace SD {
    
#define _STR_(x) #x
#define _STR(x)  _STR_(x)
#define HERE     __FILE__ " (" _STR(__LINE__) "): "

// typedef
typedef float        Real;
typedef unsigned int Label;

// Constant values
const unsigned int MAX_LENGTH      = 1024;
const unsigned int MAX_BYTE_LENGTH = 1024*128;
const unsigned int BUFF_SIZE       = 1024*1024;
const Real         ZERO            = 0.0f;
const Real         MIN_VALUE       = -1*FLT_MAX;
const int          SUCCESS         = 0;
const int          FAILURE         = -1;

template<class K, class V> struct cmp_second {
    bool operator()( const std::pair<K,V>& rhs, const std::pair<K,V>& lhs ) const {
	return rhs.second > lhs.second;
    }
};


inline unsigned int pow2( unsigned int n ) {

    unsigned int r = 1;
    for ( unsigned int i = 0; i < n; ++i ) {
	r *= 2;
    }
    return r;
}


inline unsigned int degenerate_label_num( unsigned int L ) {

    unsigned int D = 0;
    unsigned int m = 1;
    while ( m < L ) {
	++D;
	m *= 2;
    }
    return D;
}

}

#endif
